/*
 File: wysuwygOverlay.js
 Copyright: Rahul Singh
 Mail: induscrypt@gmail.com
 Source: http://wysuwyg.mozdev.org
 Referenced by: wysuwygOverlay.xul
 Description: The javascript that contains backend code for the overlay
 			Launches the html page containing the main editor
 			Listens for menu and contect meu commands
 			Provides tolerance for immature closing of source window etc.
 			Provides functilonality for dealing with tabs
 Acknowledgements: Functions openXinhaWin  and initOverlay borrow heavily 
 			from Xinha Here! by Jayson Harshbarger at hypercubed.com
 			

*/



//a class that will hold all the functions
//and data for the Overlay

var hello = {
 
col :null, 
ta : null,
ta_html : null,
ta_url : null,
ta_doc : null,  //current document
ta_doc_tab : null, //browser tab with current doc 
	
	openXinhaWin : function ()
	{
	//this.col= window.document.bgColor; 
	this.ta = document.commandDispatcher.focusedElement;
	if (this.ta !=null)
	{
	this.ta_html = this.ta.value;
		
	this.ta_doc = gBrowser.contentDocument;
	this.ta_url = gBrowser.contentDocument.URL;	 //topWin.getBrowser().contentDocument.URL;
	this.ta_doc_tab=gBrowser.selectedTab ;
	//alert("bgcolor=  "+ this.col );
	
	}
	//nxt 2 lines copied from xinhaHere
	var e_par = "toolbar=no,menubar=no,personalbar=no,status=no,width=800,height=660,"
				+"centerscreen=yes ,scrollbars=no,resizable=yes,dependent=no,chrome=no modal=no" ;
	var e_win = window.open("chrome://wysuwyg/content/EditorPageWindowed.html", "editor_xul", e_par);
	
	if (e_win==null){alert('Sorry! Editor window could not be launched.\nAre you using a pop-up blocker?');return;}
	
	//e_win.sizeToContent() ;
	
	}, //end function
	
	
	
	
	//Inventing a Tabbed Wheel
	
	
	
	openXinhaTab : function ()
	{
	this.ta_url=null; //flush url, the event-based system picks old statics!!
	this.ta = document.commandDispatcher.focusedElement;
	
	if (this.ta !=null)
	{
	this.ta_html = this.ta.value;		
	this.ta_doc = gBrowser.contentDocument;
	this.ta_url = gBrowser.contentDocument.URL;	 //topWin.getBrowser().contentDocument.URL;
	this.ta_doc_tab=gBrowser.selectedTab ;
	//alert("bgcolor=  "+ this.col );	
	}
	
	
	var editor_tab=null;
	var editor_doc=null;
	var editor_tab = gBrowser.addTab("chrome://wysuwyg/content/EditorPageTabbed.html");

	document.addEventListener("ExtTalkEventGet", this.myTabListener , false, true);//at start
	document.addEventListener("ExtTalkEventSet", this.myTabListener , false, true);//at end
	
	gBrowser.selectedTab =editor_tab;
	//now you can get the document containing editor 
	//editor_doc = gBrowser.contentDocument;
	//leave a tag on that page so that
	//it can 'call back'
	
	//[--forget it, we'll use events]
		
	},//end function


 // BEFORE closing the editor check if the original window->tab->document 
 //is still available
 checkSourceDoc: function (){
  //first check if the tab is still available  
  
   try{
   gBrowser.selectedTab=this.ta_doc_tab ;
   var nowdoc= gBrowser.contentDocument;
   if (nowdoc!=this.ta_doc) return false;
   else return true;
   }catch (ex){return false;} 
  
  },


	//Capture custom event from a page opened in a tab

	myTabListener: function (e) {
	//TO DO : ADD safety code
	
	try{
	//alert('OVerlay catches Event \n'+ e.target.getAttribute("att_sourceTAtxt") +'\n'+'ta->'+ hello.helpVal());
	
  	var req=e.target.getAttribute("att_mode") ; //what is the request?
  	
  	
  	//now, set the values for the attributes for that element
  		if (req=='getData')
  		{
  		//ok, this static looking affair is messy, but 'this.xx' doesn't work
  		e.target.setAttribute("att_sourceURL", hello.ta_url); 
  		e.target.setAttribute("att_sourceTAtxt", hello.ta_html);
  		}
  		
  		else if  (req=='setData')
  		{
  		if (!hello.checkSourceDoc() ){alert('The original TextBox is no more available!\n Please copy your text');} 
  		else
  		hello.ta.value=e.target.getAttribute("att_sourceTAtxt");  
  		//return true;
  		}
  	 }catch (ex) {alert('Error:in Overlay \n'+ex.message );}
  	   
	},


 //not used, just some debug
 helpVal: function()
 {
     return this.ta.value;
 },
  


//these 2 functions copied from Xinha here	
	
  initOverlay: function() {
  	var menu = document.getElementById("contentAreaContextMenu");
  	menu.addEventListener("popupshowing", hello.contextPopupShowing, false);
  },
	
	// show context menu only for textarea
	contextPopupShowing: function()
	{
  	gContextMenu.showItem("men_wysuwyg", gContextMenu.onTextInput);
  	//gContextMenu.showItem("men_sribble2", gContextMenu.onTextInput);
	
    },
    
    
  
  
} //end hello


//document.addEventListener("ExtTalkEvent", this.myTabListener, false, true);
window.addEventListener("load", hello.initOverlay, false);
